/* REVEAL.C 1.1 turns off HIDDEN attribute in given set of
 * positive and negative wildcards e.g.
 * REVEAL.Exe  C:\*.* -autoexec.* C:\*.C/S
 *
 * Acts like DOS ATTRIB -H
 *
 * companion to HIDE.C
 *
 * Requires freeware CMP WILD C source package compiled
 * with COMPACT DOS model under Borland C++ 5.01.
 *
 * copyright 1993, 1998 by Roedy Green
 */

/*
Roedy Green
Canadian Mind Products
#208 - 525 Ninth Street
New Westminster BC Canada
V5H 2N6
tel:(604) 777-1804
mailto:roedy@mindprod.com
http://mindprod.com

version 1.1 1998 November 11
- embed Barker address

*/


/* I N C L U D E S */

/* allow _find_t instead of find_t */
#define __MSC 1

#include <stdlib.h> /* toupper */
#include <stdio.h>  /* fopen fread  */
#include <dos.h>    /* _dos_findnext */
#include "wild.h"   /* Wildcard processing code */

/* ************************************** */

void Banner(void)
{
  /* copyright banner, not displayed, just embedded. */
  printf("\n REVEAL 1.1 ۲\n\n"
         "Freeware to turn off HIDDEN file attribute bits in +ve or -ve wildcards. \n"
         "Copyright (c) 1990,1998 Canadian Mind Products\n"
         "\n" "#208 - 525 Ninth Street, New Westminster, BC Canada V3M 5T9"
         "\n" "tel:(604) 777-1804   mailto:roedy@mindprod.com   http://mindprod.com"
         "\n" "May be used freely for non-military use only"
         "\n\n");
} /* Banner */

/* ************************************** */

local void ProcessWilds(WORD argc, char **argv)
/* process list of expanded wildcards turning on HIDDEN attributes. */
{
  WORD             i;
  ATTRIB           Attrib;
  for ( i = 0; i < argc; i++ )
    {
    /* turn off the HIDDEN attribute in each file in the list */
    (void) _dos_getfileattr(argv[i],&Attrib);
    (void) _dos_setfileattr(argv[i],Attrib & (~_A_HIDDEN));
    }

  printf("%u files revealed\n", argc);

  Wild_Free();
  /* Free up the pointers and strings to the expanded
   * Wildcards. */
}

/* ************************************** */

BOOL HiddenFilesOnly(ATTRIB Attrib)
/* TRUE if attribute describes a hidden file -- not
 * Dir Vol.  Possibly Archive, system.
 * No need to process files already revealed. */
{
  return (Wild_AttribPatternMatch("?00?1?", /* ADVSHR */
                                  Attrib));
}
/* ************************************** */

/* M A I N */

int main(int argc, char **argv)

/* Ask Wild to process all parms but not argv[0] -- the progname. We give it
 * two callback functions -- one to filter attribs and one to
 * process the wildcards. ProcessWilds is our user routine that
 * does all the work. The list of wildcards could come from
 * anywhere, not just argv. */
{
  Wild(HiddenFilesOnly, ProcessWilds, (unsigned int) (argc - 1), argv + 1);
  return (0) /* DOS ERRORLEVEL */;
}

/* ************************************** */

/* -30- */
